using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Configuration;
using System.Xml;
using System.IO;

/// <summary>
/// Summary description for Send
/// </summary>
public class DataHelper
{
    private static string _Queue;
    private static string _Sended;

    static DataHelper(){
        _Queue = WebConfigurationManager.AppSettings["XmlDir"] + "Queue.xml";
        _Sended = WebConfigurationManager.AppSettings["XmlDir"] + "Sended.xml";
    }

    public static string FileQueue
    {
        get { return _Queue; }
    }

    public static string FileSended
    {
        get { return _Sended; }
    }

    public static void Send()
    {
        XmlTextWriter writer;
        XmlDocument xmlQueue;
        XmlDocument xmlSended;

        xmlSended = new XmlDocument();
        xmlSended.Load(_Sended);

        using(FileStream fileQueue = new FileStream( _Queue, FileMode.OpenOrCreate, FileAccess.ReadWrite, FileShare.None)){


            xmlQueue = new XmlDocument();
            xmlQueue.Load(fileQueue);



            string fragmentTemplate = "<item><email>{0}</email><dataInvio>{1} {2}</dataInvio></item>";

            foreach (XmlNode node in xmlQueue.SelectNodes("/emails/email"))
            {
                //Create a document fragment.
                XmlDocumentFragment docFrag = xmlSended.CreateDocumentFragment();
             
                //Set the contents of the document fragment.
                docFrag.InnerXml = String.Format(fragmentTemplate, node.InnerText, DateTime.Now.ToLongDateString(), DateTime.Now.ToLongTimeString());

               //Add the children of the document fragment to the
               //original document.
                xmlSended.DocumentElement.AppendChild(docFrag);
            }

            xmlQueue.DocumentElement.RemoveAll();



        }

        //fileToSend.Seek(0, SeekOrigin.End);

        writer = new XmlTextWriter(_Queue, System.Text.Encoding.UTF8);
        writer.Formatting = Formatting.Indented;
        xmlQueue.WriteTo(writer);
        writer.Flush();
        writer.Close();

        writer = new XmlTextWriter(_Sended, System.Text.Encoding.UTF8);
        writer.Formatting = Formatting.Indented;
        xmlSended.WriteTo( writer );
        writer.Flush();
        writer.Close();

    }

    public static void AddToQueue(string sToAdd) 
    {
        XmlDocument xmlQueue = new XmlDocument();
        xmlQueue.Load(_Queue);

        string fragmentTemplate = "<email>{0}</email>";

        XmlDocumentFragment docFrag = xmlQueue.CreateDocumentFragment();

        //Set the contents of the document fragment.
        docFrag.InnerXml = String.Format(fragmentTemplate, sToAdd);

        //Add the children of the document fragment to the
        //original document.
        xmlQueue.DocumentElement.AppendChild(docFrag);

        using (XmlTextWriter writer = new XmlTextWriter(_Queue, System.Text.Encoding.UTF8))
        {
            writer.Formatting = Formatting.Indented;
            xmlQueue.WriteTo(writer);
            writer.Flush();
            writer.Close();
        }
    }
}
